From a232ce0c582b2cc2b3575ac587a7b1e650192bb5 Mon Sep 17 00:00:00 2001
From: basos g <noxelia 4t gmail d0t c0m>
Date: Mon, 6 Apr 2009 15:31:26 +0000
Subject: [PATCH 18/20] CLEAN QT4 fix some memory leaks. Reorgazine code

---
 modules/gui/qt4/components/open_panels.cpp |   17 +++++++++++------
 1 files changed, 11 insertions(+), 6 deletions(-)

diff --git a/modules/gui/qt4/components/open_panels.cpp b/modules/gui/qt4/components/open_panels.cpp
index 4899144..97b1399 100644
--- a/modules/gui/qt4/components/open_panels.cpp
+++ b/modules/gui/qt4/components/open_panels.cpp
@@ -1241,9 +1241,14 @@ void CaptureOpenPanel::advancedDialog()
     for( int n = 0; n < (int)i_confsize; n++ )
     {
         module_config_t *p_item = p_config + n;
+        if ( p_item->i_type & CONFIG_HINT || !p_item->b_advanced )
+            continue ;
         ConfigControl *config = ConfigControl::createControl(
                         VLC_OBJECT( p_intf ), p_item, advFrame, gLayout, n );
-        controls.append( config );
+        if ( config )
+            controls.append( config );
+        else
+            msg_Dbg( p_intf, "This shouldn't happen, please report (%s)", p_item->psz_name );
     }
 
     /* Button stuffs */
@@ -1266,11 +1271,6 @@ void CaptureOpenPanel::advancedDialog()
         for( int i = 0; i < controls.size(); i++ )
         {
             ConfigControl *control = controls[i];
-            if( !control )
-            {
-                msg_Dbg( p_intf, "This shouldn't happen, please report" );
-                continue;
-            }
 
             tempMRL += (i ? " :" : ":");
 
@@ -1300,6 +1300,11 @@ void CaptureOpenPanel::advancedDialog()
         updateMRL();
         msg_Dbg( p_intf, "%s", qtu( advMRL ) );
     }
+    for( int i = 0; i < controls.size(); i++ )
+    {
+        ConfigControl *control = controls[i];
+        delete control ;
+    }
     delete adv;
     module_config_free( p_config );
     module_release (p_module);
-- 
1.6.1.3

